DECLARE FUNCTION GetKey% ()
DECLARE SUB TD.RotateFace (RotationX%, RotationY%, RotationZ%)
DECLARE SUB TD.ProjectFace (Method%)
DECLARE SUB TD.TranslateFace (Zoom%)
DECLARE SUB TD.BufferFace (Point1 AS ANY, Point2 AS ANY, Point3 AS ANY, Point4 AS ANY)
DECLARE SUB TD.Init ()
DECLARE SUB Load3DP (File$)

'**************************************************************************
'*
'* 3DES SDK beta 1
'* (c) 1999 Bas Tossings
'*
'**************************************************************************

DEFINT A-Z

CONST MaxNumberOfPlanes = 300   '<------------------ adjust this to set
				'                    the maximum number
				'                    of planes that can be
				'                    used...
				'                    (larger=more mem req.)
TYPE PointType
	X AS INTEGER
	Y AS INTEGER
	Z AS INTEGER
END TYPE

DIM SHARED NumberOfPlanes AS INTEGER
DIM SHARED IntegerDummy AS INTEGER
DIM SHARED LayerName$(16)
DIM SHARED PlaneLayer(MaxNumberOfPlanes)
DIM SHARED PlanePoints(MaxNumberOfPlanes, 4) AS PointType

'// Clear screen
CLS

'// Setup 3D engine
TD.Init

'// Load a model
Model$ = "c:\qb2\projects\3des\3dp\3dpplane.3dp"
PRINT "Loading model "; UCASE$(Model$)
Load3DP Model$
PRINT "Model OK"

SCREEN 7, , 1, 0

'// Test projection

rX = 0
rY = 0
rZ = 0

T! = TIMER
Frames = 0
FPS = 0
DO
	IF TIMER - T! >= 1 THEN
		FPS = Frames
		Frames = 0
		T! = TIMER
	END IF
       
	FOR Buffer = 1 TO 16
		Dummy$ = INKEY$
	NEXT
       
	KeyCode = GetKey
	IF KeyCode = 72 THEN rX = rX + 1
	IF KeyCode = 80 THEN rX = rX - 1
       
	IF KeyCode = 75 THEN rY = rY - 1
	IF KeyCode = 77 THEN rY = rY + 1

	rX = rX MOD 360: IF rX < 0 THEN rX = 360 + rX
	rY = rY MOD 360: IF rY < 0 THEN rY = 360 + rY
	'rZ = rZ MOD 360: IF rZ < 0 THEN rZ = 360 + rZ
       
	CLS
	LOCATE 1, 1: PRINT FPS'KeyCode
	FOR Face = 1 TO NumberOfPlanes
		TD.BufferFace PlanePoints(Face, 1), PlanePoints(Face, 2), PlanePoints(Face, 3), PlanePoints(Face, 4)
		TD.RotateFace rX, rY, rZ
		TD.TranslateFace 45
		TD.ProjectFace 1
	NEXT
       
	PCOPY 1, 0
	Frames = Frames + 1

LOOP UNTIL KeyCode = 1

FUNCTION GetKey
	GetKey = INP(&H60)
END FUNCTION

SUB Load3DP (File$)
	FileHandle = FREEFILE

	OPEN File$ FOR BINARY AS FileHandle
	IF LOF(FileHandle) = 0 THEN
		CLOSE FileHandle
		KILL File$
		PRINT "File does not exist"
		END
	END IF

	'*** header ***

	ID$ = INPUT$(5, FileHandle)
	IF ID$ <> "3DPBT" THEN PRINT "ERROR: Not a valid file ID: ["; ID$; "]": END

	StringDummy$ = INPUT$(20, FileHandle)   '<------------------ not used yet

	GET #1, , NumberOfPlanes
       
	GET #1, , IntegerDummy  '<-------------------------- not used yet

	'*** layer names ***

	FOR LayerIdx = 1 TO 16
		LayerName$(LayerIdx) = INPUT$(40, FileHandle)
	NEXT

	'*** plane data ***

	FOR PlaneIdx = 1 TO NumberOfPlanes
		PlaneLayer(PlaneIdx) = ASC(INPUT$(1, FileHandle))'<- only useful when using
							 '   layers, otherwise ignore
		GET #1, , IntegerDummy   '<----------------- not used yet
		FOR PointIdx = 1 TO 4
			GET FileHandle, , PlanePoints(PlaneIdx, PointIdx)
		NEXT
	NEXT

	'*** file end ***

	CLOSE FileHandle
END SUB

