DECLARE SUB TD.DrawFillpoly (x1%, y1%, x2%, y2%, x3%, y3%, x4%, y4%, Col%)
DECLARE SUB TD.Flatten3D (X AS SINGLE, Y AS SINGLE, Z AS SINGLE, SX%, SY%, Zoom%)
DECLARE SUB TD.RotatePoint (OriginX AS SINGLE, OriginY AS SINGLE, X AS SINGLE, Y AS SINGLE, Deg%)

'
' 3D Routines for 3DES SDK beta 1
' (c) 1999 Bas Tossings
'

DEFINT A-Z

TYPE TDPointType
        X AS SINGLE
        Y AS SINGLE
        Z AS SINGLE
END TYPE

TYPE TDRoundPointType
        X AS INTEGER
        Y AS INTEGER
        Z AS INTEGER
END TYPE

TYPE FlatPointType
        X AS INTEGER
        Y AS INTEGER
END TYPE

DIM SHARED CosTable(0 TO 359) AS SINGLE
DIM SHARED SinTable(0 TO 359) AS SINGLE

DIM SHARED TempPoly(4) AS FlatPointType
DIM SHARED TempFace(4) AS TDPointType

SUB TD.BufferFace (Point1 AS TDRoundPointType, Point2 AS TDRoundPointType, Point3 AS TDRoundPointType, Point4 AS TDRoundPointType)
        TempFace(1).X = CSNG(Point1.X)
        TempFace(1).Y = CSNG(Point1.Y)
        TempFace(1).Z = CSNG(Point1.Z)
       
        TempFace(2).X = CSNG(Point2.X)
        TempFace(2).Y = CSNG(Point2.Y)
        TempFace(2).Z = CSNG(Point2.Z)

        TempFace(3).X = CSNG(Point3.X)
        TempFace(3).Y = CSNG(Point3.Y)
        TempFace(3).Z = CSNG(Point3.Z)

        TempFace(4).X = CSNG(Point4.X)
        TempFace(4).Y = CSNG(Point4.Y)
        TempFace(4).Z = CSNG(Point4.Z)
END SUB

SUB TD.DrawFillpoly (x1, y1, x2, y2, x3, y3, x4, y4, Col)
  mny = y1
  mxy = y1
  IF y2 < mny THEN mny = y2
  IF y2 > mxy THEN mxy = y2
  IF y3 < mny THEN mny = y3
  IF y3 > mxy THEN mxy = y3 '{ Choose the min y mny and max y mxy }
  IF y4 < mny THEN mny = y4
  IF y4 > mxy THEN mxy = y4

  IF mny < 0 THEN mny = 0
  IF mxy > 199 THEN mxy = 199
  IF mny > 199 THEN EXIT SUB
  IF mxy < 0 THEN EXIT SUB      '{ Vertical range checking }

  mul1 = x1 - x4
  div1 = y1 - y4
  mul2 = x2 - x1
  div2 = y2 - y1
  mul3 = x3 - x2
  div3 = y3 - y2
  mul4 = x4 - x3
  div4 = y4 - y3 '{ Constansts needed for intersection calc }

  FOR Yc = mny TO mxy
      mnx = 320
      mxx = -1
      IF y4 >= Yc OR y1 >= Yc THEN
        IF y4 <= Yc OR y1 <= Yc THEN '{ Check that yc is between y1 and y4 }
          IF NOT y4 = y1 THEN
              X = (Yc - y4) * mul1 / div1 + x4'{ Point of intersection on x axis }
              IF X < mnx THEN mnx = X
              IF X > mxx THEN mxx = X     '{ Set point as start or end of horiz line }
           END IF
        END IF
      END IF
      IF y1 >= Yc OR y2 >= Yc THEN
        IF y1 <= Yc OR y2 <= Yc THEN '{ Check that yc is between y1 and y2 }
          IF NOT y1 = y2 THEN
              X = (Yc - y1) * mul2 / div2 + x1 '{ Point of intersection on x axis }
              IF X < mnx THEN mnx = X
              IF X > mxx THEN mxx = X     '{ Set point as start or end of horiz line }
           END IF
        END IF
      END IF
      IF y2 >= Yc OR y3 >= Yc THEN
        IF y2 <= Yc OR y3 <= Yc THEN '{ Check that yc is between y2 and y3 }
          IF NOT y2 = y3 THEN
              X = (Yc - y2) * mul3 / div3 + x2 '{ Point of intersection on x axis }
              IF X < mnx THEN mnx = X
              IF X > mxx THEN mxx = X     '{ Set point as start or end of horiz line }
           END IF
        END IF
      END IF
      IF y3 >= Yc OR y4 >= Yc THEN
        IF y3 <= Yc OR y4 <= Yc THEN '{ Check that yc is between y3 and y4 }
          IF NOT y3 = y4 THEN
              X = (Yc - y3) * mul4 / div4 + x3'{ Point of intersection on x axis }
              IF X < mnx THEN mnx = X
              IF X > mxx THEN mxx = X     '{ Set point as start or end of horiz line }
           END IF
        END IF
      END IF
      IF mnx < 0 THEN mnx = 0
      IF mxx > 319 THEN mxx = 319
      IF mnx <= mxx THEN LINE (mnx, Yc)-(mxx, Yc), Col
      '{ Draw the horizontal line }
   NEXT
END SUB

'----------------------------------------------------------------------------
'         Transforms 3D coordinates into 2D screen coordinates
'----------------------------------------------------------------------------
SUB TD.Flatten3D (X AS SINGLE, Y AS SINGLE, Z AS SINGLE, SX, SY, Zoom)
        IF Z - Zoom < 0 THEN SY = CINT((Y + My) * 256 / (Z - Zoom))
        IF Z - Zoom < 0 THEN SX = CINT((X + Mx) * 256 / (Z - Zoom))
END SUB

SUB TD.Init
        '// setup lookup tables
        FOR Deg = 0 TO 359
               CosTable(Deg) = COS(Deg / 57.2958)
               SinTable(Deg) = SIN(Deg / 57.2958)
        NEXT

        '// init rotation parameters
        RotationX = 0
        RotationY = 0
        RotationZ = 0
END SUB

SUB TD.ProjectFace (Method)
        OffsetX = 160
        OffsetY = 100
        SELECT CASE Method
                CASE 1
                        '// Line projection
                        LINE (TempPoly(1).X + OffsetX, TempPoly(1).Y + OffsetY)-(TempPoly(2).X + OffsetX, TempPoly(2).Y + OffsetY), 15
                        LINE (TempPoly(2).X + OffsetX, TempPoly(2).Y + OffsetY)-(TempPoly(3).X + OffsetX, TempPoly(3).Y + OffsetY), 15
                        LINE (TempPoly(3).X + OffsetX, TempPoly(3).Y + OffsetY)-(TempPoly(4).X + OffsetX, TempPoly(4).Y + OffsetY), 15
                        LINE (TempPoly(4).X + OffsetX, TempPoly(4).Y + OffsetY)-(TempPoly(1).X + OffsetX, TempPoly(1).Y + OffsetY), 15
                CASE 2
                        '// Solid wireframe
                        TD.DrawFillpoly TempPoly(1).X + OffsetX, TempPoly(1).Y + OffsetY, TempPoly(2).X + OffsetX, TempPoly(2).Y + OffsetY, TempPoly(3).X + OffsetX, TempPoly(3).Y + OffsetY, TempPoly(4).X + OffsetX, TempPoly(4).Y + OffsetY, 0
                        LINE (TempPoly(1).X + OffsetX, TempPoly(1).Y + OffsetY)-(TempPoly(2).X + OffsetX, TempPoly(2).Y + OffsetY), 15
                        LINE (TempPoly(2).X + OffsetX, TempPoly(2).Y + OffsetY)-(TempPoly(3).X + OffsetX, TempPoly(3).Y + OffsetY), 15
                        LINE (TempPoly(3).X + OffsetX, TempPoly(3).Y + OffsetY)-(TempPoly(4).X + OffsetX, TempPoly(4).Y + OffsetY), 15
                        LINE (TempPoly(4).X + OffsetX, TempPoly(4).Y + OffsetY)-(TempPoly(1).X + OffsetX, TempPoly(1).Y + OffsetY), 15
                CASE ELSE
        END SELECT
END SUB

SUB TD.RotateFace (RotationX, RotationY, RotationZ)
        FOR Pnt = 1 TO 4
                TD.RotatePoint 0, 0, TempFace(Pnt).X, TempFace(Pnt).Z, RotationY
                TD.RotatePoint 0, 0, TempFace(Pnt).Z, TempFace(Pnt).Y, RotationX
                'TD.RotatePoint 0, 0, TempFace(Pnt).Y, TempFace(Pnt).X, RotationZ
        NEXT
END SUB

SUB TD.RotatePoint (OriginX AS SINGLE, OriginY AS SINGLE, X AS SINGLE, Y AS SINGLE, Deg)
        DIM tX AS SINGLE, tY AS SINGLE
        tX = X - OriginX
        tY = Y - OriginY
        X = (((CosTable(Deg) * tX) - (SinTable(Deg) * tY))) + OriginX
        Y = (((SinTable(Deg) * tX) + (CosTable(Deg) * tY))) + OriginY
END SUB

SUB TD.TranslateFace (Zoom)
        FOR Pnt = 1 TO 4
                TD.Flatten3D TempFace(Pnt).X, TempFace(Pnt).Y, TempFace(Pnt).Z, TempPoly(Pnt).X, TempPoly(Pnt).Y, Zoom
        NEXT
END SUB

